﻿using UnityEngine;
using FMODUnity;
using HarmonyLib;
using Steamworks;
using System;
using System.Collections.Generic;
using System.Linq;

public class Mermaid_miner : Mod
{
	Transform itemParent;
	Landmark currentIsland = null;
	//List<uint> Landmarks = null;
	//Dictionary<uint, Landmark> LandmarksMap = null;
	Network_Player player = null;
	string CurrentDiffculty = "";
	Dictionary<int, bool>itemFilters = null;
	bool isModLoaded = false;
	bool inGame = false;
	//float Refreshtimer = 0.0f;
	List<PickupItem> IslandResource = null;
	//bool AutoDetect = false;
	
    public void Start()
    {
        Debug.Log("Mod Mermaid_miner has been loaded!");
    }

    public void OnModUnload()
    {
        Debug.Log("Mod Mermaid_miner has been unloaded!");
    }
	/*public override void LocalPlayerEvent_DropItem(ItemInstance item, Vector3 position, Vector3 direction, bool parentedToRaft)
	{
		if(!MatchDiffculty(CurrentDiffculty, item.baseItem))
			return;
		if(IslandResource == null || IslandResource.Count == 0)
		{
		
			if(!DetectStart())
			{
				UnityEngine.Debug.Log("Update => Island has mined or Detect Failed");
				return;
			}
		}
		
		bool Result = sacrifice(item);
		if(!Result)
			return;
		
		try
		{
			PickUpAll();
		}catch(Exception e)
		{
			UnityEngine.Debug.Log("LocalPlayerEvent_DropItem => fail => " + e.Message);
		}
		
		if(item.Amount == 0)
			item = null;
		
	}*/
	public void PickUpAll()
	{
		UnityEngine.Debug.Log("PickUpAll => start");
		if(IslandResource == null || IslandResource.Count == 0)
			return;
		
		if (player == null)
		{
			player = RAPI.GetLocalPlayer();
		}
		foreach(PickupItem pi in IslandResource)
		{
			player.PickupScript.PickupItem(pi, true, false);
			if(CurrentDiffculty != "Every easy")
				Luck();
		}
		
		
		IslandResource.Clear();
	}
	
	public void Luck()
	{
		if (player == null)
		{
			player = RAPI.GetLocalPlayer();
		}
		int dice = 0;

		if(CurrentDiffculty == "Easy")
			dice = UnityEngine.Random.Range(0, 100000);

		if(CurrentDiffculty == "Medium")
			dice = UnityEngine.Random.Range(0, 10000);

		if(CurrentDiffculty == "Hard")
			dice = UnityEngine.Random.Range(0, 5000);

		if(CurrentDiffculty == "SM")
			dice = UnityEngine.Random.Range(0, 1000);
		if(dice == 1)
		{
			UnityEngine.Debug.Log("Luck => you are so lucky...");
			RAPI.GiveItem(ItemManager.GetItemByName("TitaniumOre"), 1); 
		}
	}
	
	
	public override void WorldEvent_WorldLoaded()
	{
		inGame = true;
		
		BuildSetting();
		if(!DetectStart())
			UnityEngine.Debug.Log("Update => Detect failed");
		if(IslandResource == null || IslandResource.Count == 0)
			UnityEngine.Debug.Log("WorldEvent_WorldLoaded => no Island Resource!!");
	}
	public void ExtraSettingsAPI_SettingsClose()
    {
		BuildSetting();
	}
	public void Update()
	{
		if (!isModLoaded || !inGame)
			return;
		
		
		//Refreshtimer += Time.deltaTime;
		//UnityEngine.Debug.Log("Update => Refreshtimer => " + Refreshtimer.ToString());
		if (Input.GetKey(KeyCode.A) && Input.GetKey(KeyCode.LeftControl))
		{
			if((IslandResource != null && IslandResource.Count != 0) || DetectStart())
				sacrifice_item();
			return;
		}
		/*if (!AutoDetect)
			return;
		if (Refreshtimer < 10f)
		{
			return;
		}

		if((IslandResource != null && IslandResource.Count != 0) || DetectStart())
			sacrifice_item();
		else
			UnityEngine.Debug.Log("Update => Detect failed");
		
		Refreshtimer = 0.0f;*/
	}
	
	bool DetectStart()
	{
		try
		{
			SearchForIsland();
			SearchForItems();
			if(IslandResource == null || IslandResource.Count == 0)
			{
				UnityEngine.Debug.Log("DetectStart => This Island has no resoure");
				return false;
			}
			
		}
		catch (Exception e)
		{
			UnityEngine.Debug.Log("DetectStart => SearchForIsland => " + e.Message);
			return false;
		}
		return true;
		
	}
	
	/*public bool IslandChanged()
	{
		UnityEngine.Debug.Log("IslandChanged => start check");
		if (player == null)
		{
			player = RAPI.GetLocalPlayer();
			return false;
		}
		Landmark[] AllLandmarks = GameObject.FindObjectsOfType<Landmark>();
		Dictionary<uint, Landmark> NewLandmarksMap = new Dictionary<uint, Landmark>();
		List<uint> NewLandmarks = new List<uint>();
		if (AllLandmarks.Length <= 1)
		{
			UnityEngine.Debug.Log("IslandChanged => no island");
			return false;
		}
		
		if (currentIsland == null || Landmarks == null  || LandmarksMap == null || Landmarks.Count <= 0 || LandmarksMap.Count <= 0)
		{
			UnityEngine.Debug.Log("IslandChanged => first");
			return true;
		}
		for (int i = 0; i < AllLandmarks.Length; i++)
		{
			if (AllLandmarks[i] != null && !AllLandmarks[i].name.Contains("Raft"))
			{
				NewLandmarksMap.Add(AllLandmarks[i].uniqueLandmarkIndex, AllLandmarks[i]);
				NewLandmarks.Add(AllLandmarks[i].uniqueLandmarkIndex);
			}
		}
		if (NewLandmarks == null  || NewLandmarksMap == null || NewLandmarks.Count <= 0 || NewLandmarksMap.Count <= 0)
		{
			return false;
		} 
		bool Result = ListCompare(Landmarks, NewLandmarks);
		NewLandmarks.Clear();
		NewLandmarksMap.Clear();
		UnityEngine.Debug.Log("IslandChanged => the same Islands => " + Result.ToString());
		if(Result == false)
			return !Result;
		
		Landmark nearestLandmark = null;
		float dist = float.MaxValue;
		foreach(uint LandmarkID in Landmarks)
		{
			if (Vector3.Distance(LandmarksMap[LandmarkID].transform.position, player.transform.position) < dist)
			{
				
				dist = Vector3.Distance(LandmarksMap[LandmarkID].transform.position, player.transform.position);
				nearestLandmark = LandmarksMap[LandmarkID];
				UnityEngine.Debug.Log("IslandChanged => the same Issland id => " + Result.ToString());
			}
		}
		Result = (nearestLandmark.uniqueLandmarkIndex == currentIsland.uniqueLandmarkIndex);
		UnityEngine.Debug.Log("IslandChanged => the same Issland id => " + Result.ToString());
		Result = Result && (nearestLandmark == currentIsland);
		UnityEngine.Debug.Log("IslandChanged => the same Issland object => " + Result.ToString());
		return !Result;
	}*/
	public void sacrifice_item()	
	{
		if (player == null)
		{
			player = RAPI.GetLocalPlayer();
		}
		PlayerInventory inv = player.Inventory;
		if(inv == null)
		{
			UnityEngine.Debug.Log("sacrifice_item => playerInventory == null!!");
			return;
		}
		UnityEngine.Debug.Log("sacrifice_item => playerInventory not null!!");
		if(IslandResource == null || IslandResource.Count == 0)
			return;
		UnityEngine.Debug.Log("sacrifice_item => has IslandResource!!");
		foreach(Slot slot in inv.allSlots)
		{
			
			if(slot == null || slot.IsEmpty || !slot.HasValidItemInstance() || slot.itemInstance == null)
				continue;
			if(MatchDiffculty(CurrentDiffculty, slot.itemInstance.baseItem))
			{
				UnityEngine.Debug.Log("sacrifice_item => sacrifice Match!!");
				if(IslandResource.Count > 5)
					slot.RemoveItem(1);
				PickUpAll();
				return;
			}
		}
	}
	public bool sacrifice(ItemInstance item)
	{
		if(!MatchDiffculty(CurrentDiffculty, item.baseItem))
			return false;
		if(IslandResource.Count > 5)
			item.Amount--;
		return true;
	}
	public List<ItemInstance> ToItemInstance(PickupItem pi)
	{
		List<ItemInstance> items = new List<ItemInstance>();
		if(pi == null)
			return items;
		
		UnityEngine.Debug.Log("ToItemInstance");
		
		try
		{
			UnityEngine.Debug.Log("ToItemInstance => itemInstance => " + pi.itemInstance.baseItem.settings_Inventory.DisplayName);
			items.Add(pi.itemInstance);
		}catch(Exception e)
		{
			UnityEngine.Debug.Log("ToItemInstance => no itemInstance => " + e.Message);
		}
		
		if(pi.dropper != null)
		{
			Item_Base[] randomItems = pi.dropper.GetRandomItems();
			for (int i = 0; i < randomItems.Length; i++)
			{
				if (randomItems[i] != null)
				{
					UnityEngine.Debug.Log("ToItemInstance => dropper => " + randomItems[i].settings_Inventory.DisplayName);
					items.Add(new ItemInstance(randomItems[i], 1, randomItems[i].MaxUses));
				}
			}
		}
		else
			UnityEngine.Debug.Log("ToItemInstance => dropper is null");
		
		Cost cost = null;
		try
		{
			cost = pi.yieldHandler.Yield.Last();
			
		}catch(Exception e)
		{
			UnityEngine.Debug.Log("ToItemInstance => Yield.Last is null");
		}
		if (cost == null || cost.item == null)
		{
			UnityEngine.Debug.Log("ToItemInstance => Yield is null");
		}
		else
		{
			items.Add(new ItemInstance(cost.item, cost.amount, cost.item.MaxUses));
			UnityEngine.Debug.Log("ToItemInstance => cost => " + cost.item.settings_Inventory.DisplayName);
			UnityEngine.Debug.Log("ToItemInstance => cost amount => " + cost.amount.ToString());
		}
		return items;
	}
	
	private void SearchForItems()
	{
		UnityEngine.Debug.Log("SearchForItems => start");
		if(IslandResource == null)
			IslandResource = new List<PickupItem>();
		if (currentIsland == null)
		{
			IslandResource.Clear();
			UnityEngine.Debug.Log("SearchForItems => currentIsland is null");
			return;
		}
		else
		{
			UnityEngine.Debug.Log("SearchForItems => currentIsland => " + currentIsland.name);
			//UnityEngine.Debug.Log("SearchForItems => currentIsland => " + currentIsland.GetInstanceID().ToString();
		
		}
		
		IslandResource.Clear();
		if(itemFilters == null)
			BuilditemFilters();
		foreach (LandmarkItem landmarkitem in currentIsland.landmarkItems)
		{
			PickupItem pi = landmarkitem.connectedBehaviourID.GetComponent<PickupItem>();
			List<ItemInstance> tmp = ToItemInstance(pi);
			if(tmp != null && tmp.Count > 0)
			{
				foreach(ItemInstance ii in tmp)
				{
					if(!itemFilters.ContainsKey(ii.baseItem.UniqueIndex))
						continue;
					if(itemFilters[ii.baseItem.UniqueIndex])
					{
						IslandResource.Add(pi);
						UnityEngine.Debug.Log("SearchForItems => find!! => " + ii.baseItem.settings_Inventory.DisplayName);
						break;
					}
				}
			}
		}
		


	}
	bool ListCompare(List<uint> listA, List<uint> listB)
	{
		listA.Sort();
		listB.Sort();
		var firstNotSecond = listA.Except(listB).ToList();
		var secondNotFirst = listB.Except(listA).ToList();
		return !firstNotSecond.Any() && !secondNotFirst.Any();
	}
	
	bool SearchForIsland()
	{
		UnityEngine.Debug.Log("SearchForIsland => start check");
		if (player == null)
		{
			player = RAPI.GetLocalPlayer();
		}
		//if(Landmarks == null)
		//	Landmarks = new List<uint>();
		
		//if(LandmarksMap == null)
		//	LandmarksMap = new Dictionary<uint, Landmark>();
		
		//Landmarks.Clear();
		//LandmarksMap.Clear();
		
		Landmark[] newLandmarks = GameObject.FindObjectsOfType<Landmark>();
		UnityEngine.Debug.Log("SearchForIsland => newLandmarks Length => " + newLandmarks.Length.ToString());
		Landmark[] newLandmarks1 = UnityEngine.Object.FindObjectsOfType<Landmark>();
		UnityEngine.Debug.Log("SearchForIsland => newLandmarks1 Length => " + newLandmarks1.Length.ToString());
		
		
		if (newLandmarks.Length < 1)
			return false;

		Landmark nearestLandmark = null;
		float dist = float.MaxValue;
		for (int i = 0; i < newLandmarks.Length; i++)
		{
			UnityEngine.Debug.Log("SearchForIsland => name => " + newLandmarks[i].name);
			if (newLandmarks[i] != null && !newLandmarks[i].name.Contains("Raft"))
			{
				//LandmarksMap.Add(newLandmarks[i].uniqueLandmarkIndex, newLandmarks[i]);
				//Landmarks.Add(newLandmarks[i].uniqueLandmarkIndex);
				UnityEngine.Debug.Log("SearchForIsland => uniqueLandmarkIndex => " + newLandmarks[i].uniqueLandmarkIndex.ToString());
				UnityEngine.Debug.Log("SearchForIsland => Instance ID => " + newLandmarks[i].GetInstanceID().ToString());
				
				if (Vector3.Distance(newLandmarks[i].transform.position, player.transform.position) < dist)
				{
					dist = Vector3.Distance(newLandmarks[i].transform.position, player.transform.position);
					nearestLandmark = newLandmarks[i];
					
					UnityEngine.Debug.Log("SearchForIsland => Match Island => " + newLandmarks[i].uniqueLandmarkIndex.ToString());
					UnityEngine.Debug.Log("SearchForIsland => dist => " + dist.ToString());
				}
			}

		}
		if(currentIsland != null)
			UnityEngine.Debug.Log("SearchForIsland => currentIsland => " + currentIsland.uniqueLandmarkIndex.ToString());
		else
			UnityEngine.Debug.Log("SearchForIsland => currentIsland is null");
		if(nearestLandmark != null)
			UnityEngine.Debug.Log("SearchForIsland => nearestLandmark => " + nearestLandmark.uniqueLandmarkIndex.ToString());
		else
			UnityEngine.Debug.Log("SearchForIsland => nearestLandmark is null");
		
		
		
		if (currentIsland != nearestLandmark)
		{
			currentIsland = nearestLandmark;
			if(currentIsland != null)
			{
				UnityEngine.Debug.Log("SearchForIsland => FoundNewIsland => " + currentIsland.name);
				//UnityEngine.Debug.Log("SearchForIsland => FoundNewIsland => " + currentIsland.GetInstanceID().ToString());
			}
			return true;
		}
		else
		{
			return false;
		}

		

	}
	public bool MatchDiffculty(string Diffculty, Item_Base ib)
	{
		//Thatch, Plank, Plastic
		if(Diffculty == "Every easy")
			return (ib.UniqueIndex == 25 || ib.UniqueIndex == 21 || ib.UniqueIndex == 53);
		
		//stone, scrap
		if(Diffculty == "Easy")
			return (ib.UniqueIndex == 50 || ib.UniqueIndex == 23);
		
		//Metal ingot, Copper ingot, Glass, Dry Brick
		if(Diffculty == "Medium")
			return (ib.UniqueIndex == 70 || ib.UniqueIndex == 177 || ib.UniqueIndex == 67 || ib.UniqueIndex == 73);
		
		//TradeToken, Mystery Package, Trophy Fishes
		if(Diffculty == "Hard")
			return (ib.UniqueIndex == 564 || ib.UniqueIndex == 468 || ib.UniqueName.Contains("TrophyFish"));
		
		//Titanium ingot
		if(Diffculty == "SM")
			return (ib.UniqueIndex == 307);
		return false;
	}
	
	public void BuildSetting()
	{
		if (!ExtraSettingsAPI_Loaded)
        {
            UnityEngine.Debug.Log("BuildSetting failed!");
            return;
        }
		player = RAPI.GetLocalPlayer();
		CurrentDiffculty = ExtraSettingsAPI_GetComboboxSelectedItem("difficulty");
		//AutoDetect = ExtraSettingsAPI_GetCheckboxState("auto sacrifice item");
		//bool needIron = ExtraSettingsAPI_GetCheckboxState("Item filter: Metal Ore");
		BuilditemFilters();
		//UnityEngine.Debug.Log("BuildSetting => CPID => " + CPID);
		//UnityEngine.Debug.Log("BuildSetting => needIron => " + needIron.ToString());
		isModLoaded = true;
	}
	void BuilditemFilters()
	{
		if(itemFilters == null)
			itemFilters = new Dictionary<int, bool>();
		if(itemFilters.Count > 0)
			itemFilters.Clear();
		itemFilters.Add(50, ExtraSettingsAPI_GetCheckboxState("Item filter: Stone"));
		itemFilters.Add(19, ExtraSettingsAPI_GetCheckboxState("Item filter: Metal Ore"));
		itemFilters.Add(179, ExtraSettingsAPI_GetCheckboxState("Item filter: Copper Ore"));
		itemFilters.Add(301, ExtraSettingsAPI_GetCheckboxState("Item filter: Titanium Ore"));
		itemFilters.Add(23, ExtraSettingsAPI_GetCheckboxState("Item filter: Scrap"));
		itemFilters.Add(65, ExtraSettingsAPI_GetCheckboxState("Item filter: Clay"));
		itemFilters.Add(66, ExtraSettingsAPI_GetCheckboxState("Item filter: Sand"));
		itemFilters.Add(24, ExtraSettingsAPI_GetCheckboxState("Item filter: Sea Vine"));
		itemFilters.Add(201, ExtraSettingsAPI_GetCheckboxState("Item filter: Silver Algae"));
		itemFilters.Add(51, ExtraSettingsAPI_GetCheckboxState("Item filter: Giant Clam"));
		
		/*
		,
	{
	  "name": "Item filter: Cave Mushroom",
	  "type": "checkbox",
	  "default": true
    },
	{
	  "name": "Item filter: Dirt",
	  "type": "checkbox",
	  "default": true
    }
		itemFilters.Add(198, ExtraSettingsAPI_GetCheckboxState("Item filter: Cave Mushroom"));
		itemFilters.Add(239, ExtraSettingsAPI_GetCheckboxState("Item filter: Dirt"));
		*/
	}
	
	public string ExtraSettingsAPI_GetComboboxSelectedItem(string SettingName) => "";
	public static bool ExtraSettingsAPI_GetCheckboxState(string SettingName) => new bool();
	static bool ExtraSettingsAPI_Loaded = false;
}